/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderClaseServicio;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaClaseServicioController")
@Scope("prototype")
public class BusquedaClaseServicioController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<ClaseServicio> plwClaseServico;
    private MyListbox claseServicioList;
    private Paging pagingClaseServicio;
    private Textbox txtNome;

    public MyListbox getClaseServicioList() {
        return claseServicioList;
    }

    public void setClaseServicioList(MyListbox claseServicioList) {
        this.claseServicioList = claseServicioList;
    }

    public Paging getPagingClaseServicio() {
        return pagingClaseServicio;
    }

    public void setPagingClaseServicio(Paging pagingClaseServicio) {
        this.pagingClaseServicio = pagingClaseServicio;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        claseServicioList.setItemRenderer(new RenderClaseServicio());
        claseServicioList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                ClaseServicio c = (ClaseServicio) claseServicioList.getSelected();
                verClaseServicio(c);
            }
        });

        refreshLista();

        txtNome.focus();
    }

    private void verClaseServicio(ClaseServicio c) {
        if (c == null) {
            return;
        }

        Map args = new HashMap();
        args.put("claseServicio", c);
        args.put("claseServicioList", claseServicioList);

        openWindow("/gui/catalogos/editarClaseServicio.zul",
                Labels.getLabel("editarClaseServicioController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<ClaseServicio> claseServicioBusqueda =
                new HibernateSearchObject<ClaseServicio>(ClaseServicio.class,
                pagingClaseServicio.getPageSize());

        claseServicioBusqueda.addFilterLike("descclase",
                "%" + txtNome.getText().trim().concat("%"));
        claseServicioBusqueda.addFilterNotEqual("claseservicioId", -1);

        claseServicioBusqueda.addSortAsc("descclase");
        claseServicioBusqueda.addFilterEqual("activo", Boolean.TRUE);

        plwClaseServico.init(claseServicioBusqueda, claseServicioList, pagingClaseServicio);

        if (claseServicioList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaClaseServicioController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verClaseServicio(new ClaseServicio());
    }
}
